import random
import string
import os

def randomString (length):
    return ''.join (random.choice (string.ascii_letters) for ii in range (length + 1))

	
def buildMultipartFormDataFile(contentType, filePath):
	lines = []
	
	with open(filePath, 'rb') as fin:
		data = fin.read()
	
	fileName = os.path.split(filePath)[1]
	lines.append('Content-Disposition: form-data; name="file"; filename="%s"' % fileName)
	lines.append('Content-Type: %s' % contentType)
	lines.append('')
	lines.append(data)
	return lines

	

def buildMultipartFormDataField(fieldName, data):
	lines = []
	lines.append('Content-Disposition: form-data; name="%s"' % fieldName)
	lines.append('')
	lines.append(data)
	return lines


def buildMultipartFormData(files, fields):
	boundary = '------WebKitFormBoundary' + randomString(16)
	lines = []

	for f in files:
		lines.append(boundary)
		lines += buildMultipartFormDataFile(f[0], f[1])

	for fieldName, fieldValue in fields.iteritems():
		lines.append(boundary)
		lines += buildMultipartFormDataField(fieldName, fieldValue)

	lines.append(boundary + '--')
	
	body = '\r\n'.join(lines)
	
	return (boundary[2:], body)