import copy

class SongInfo(object):
	_QUESTIONS = (('Release year', 'release_year'), 
		('If this is a remix, provide id of original song', 'remix_of_id'),
		('Groups (check upload page html code for number) (separate multiple entries by ;)', 'groups'),
		('Labels (check upload page html code for number) (separate multiple entries by ;)', 'labels'),
		('Info', 'info'),
		('Source (check upload page html code for number)', 'type'),
		('Platform (check upload page html code for number)', 'platform'),
		('Pouet ID', 'pouetid'),
		('Youtube video ID', 'ytvidid'),
		('Youtube start offset', 'ytvidoffset'),
		('Youtube link', 'LL_2'),
		('Youtube link comment', 'LL_2_comment'),
		('Game Name link', 'LL_3'),
		('Game Name link comment', 'LL_3_comment'),
		('MobyGames link', 'LL_4'),
		('MobyGames link comment', 'LL_4_comment'),
		('ArcadeHistory.com link', 'LL_5'),
		('ArcadeHistory.com link comment', 'LL_5_comment'),
		('Atari Legends link', 'LL_6'),
		('Atari Legends link comment', 'LL_6_comment'),
		('Demoscene.TV link', 'LL_7'),
		('Demoscene.TV link comment', 'LL_7_comment'),
		('Hall Of Light link', 'LL_8'),
		('Hall Of Light link comment', 'LL_8_comment'),
		('Lemon 64 link', 'LL_9'),
		('Lemon 64 link comment', 'LL_9_comment'),
		('Project2612 link', 'LL_10'),
		('Project2612 link comment', 'LL_10_comment'),
		('World of Spectrum link', 'LL_11'),
		('World of Spectrum link comment', 'LL_11_comment'),
		('ZXDemo link', 'LL_12'),
		('ZXDemo link comment', 'LL_12_comment'),
		('Direct Download link', 'LL_13'),
		('Direct Download link comment', 'LL_13_comment'),
		('CSDb.dk link', 'LL_17'),
		('CSDb.dk link comment', 'LL_17_comment'),
		('Play This Online link', 'LL_18'),
		('Play This Online link comment', 'LL_18_comment'),
		('VGMdb OST link', 'LL_19'),
		('VGMdb OST link comment', 'LL_19_comment'),
		('SoundCloud link', 'LL_21'),
		('SoundCloud link comment', 'LL_21_comment'),
		('Source file link', 'LL_22'),
		('Source file link comment', 'LL_22_comment'),
		('CSDb link', 'LL_24_comment'),
		('CSDb link comment', 'LL_24_comment')
		)
				

	def __init__(self, data):
		self.data = data
		
	def __str__(self):
		s = ''
		for (dataName, dataValue) in self.data.iteritems():
			s += '%s = %s\n' % (dataName, dataValue)
		return s
		
	def getFields(self):
		return copy.deepcopy(self.data)
		
	@staticmethod
	def buildFromInput():
		data = {'ytvidoffset' : '0'} # the youtube video offset always needs to be specified
		for (question, dataId) in SongInfo._QUESTIONS:
			userInput = raw_input(question + ': ').strip()
			if userInput:
				data[dataId] = userInput
			
		return SongInfo(data)

		
			  
if __name__ == '__main__':
	print SongInfo.buildFromInput()
