import urllib
import httplib
import httplib2
import collections
import os
import random
import string
from SongInfo import *
from MultiPart import *

'''
IncompleteRead exception workaround found on the web...
http://bobrochel.blogspot.com.br/2010/11/bad-servers-chunked-encoding-and.html

import httplib before
'''
def patch_http_response_read(func):
    def inner(*args):
        try:
            return func(*args)
        except httplib.IncompleteRead, e:
            return e.partial

    return inner
httplib.HTTPResponse.read = patch_http_response_read(httplib.HTTPResponse.read)



Pair = collections.namedtuple('Pair', 'key val')

BASE_DOMAIN = 'www.cvgm.net'
BASE_URL = 'http://'+ BASE_DOMAIN
LOGIN_URL = '/'.join((BASE_URL, 'account', 'signin', '')) # need / at the end
USER_AGENT = Pair('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.172 Safari/537.22')
CONTENT_TYPE_FORM = Pair('Content-Type', 'application/x-www-form-urlencoded')
CONTENT_TYPE_MP3 = "audio/mpeg"

http = httplib2.Http()

def printDict(d):
	for key, val in d.iteritems():
		print '%s:%s' % (str(key), str(val))

		

def printResponse(response, content):
	print '***Response***'
	printDict(response)
	print '***Content***'
	print content


def login(username, password):
	headers = {USER_AGENT.key: USER_AGENT.val,
			   CONTENT_TYPE_FORM.key: CONTENT_TYPE_FORM.val,
			   'Referer': BASE_URL + '/account/signin/'}
	body = {'username': username,
			'password': password,
			#'next': '',
			'blogin': 'Sign+in'}
	response, content = http.request(LOGIN_URL, 'POST', headers=headers, body=urllib.urlencode(body))

	#printResponse(response, content)

	rawCookie = response['set-cookie']
	return rawCookie[:rawCookie.find(';')]

	
	
def yesOrNo(question):
	while True:
		answer = raw_input(question + '(Y/n): ').strip()
		if answer == 'Y':
			return True
		elif answer == 'n':
			return False
		print 'Please answer (Y) or (n).'

		

def getSongTitle(filePath):
	fileName = os.path.split(filePath)[1]
	songName = '-'.join(fileName.split('-')[1:3]).strip()
	return songName


	
def upload(sessionId, artistId, filePath, songInfo):
	#Build body
	files = [(CONTENT_TYPE_MP3, filePath)]
	fields = songInfo.getFields()
	fields['title'] = getSongTitle(filePath)
	boundary, body = buildMultipartFormData(files, fields)		  
	
	# Build header
	uploadURL = BASE_URL + '/demovibes/artist/%d/upload/?X-Progress-ID=bece3aa81e25b17d93dd9ee993025217' % artistId
	contentType = 'multipart/form-data; boundary=%s' % boundary
	headers = {USER_AGENT.key: USER_AGENT.val,
			   CONTENT_TYPE_FORM.key: contentType,
			   'Referer': BASE_URL + '/demovibes/artist/%d/upload/' % artistId,
			   'Origin': BASE_URL,
			   'Host': BASE_DOMAIN,
			   'Connection': 'keep-alive',
			   'Cookie': sessionId}
	
	#with open('testBodyOutput.txt', 'wb') as fout:
	#	fout.write(body)
	
	response, content = http.request(uploadURL, 'POST', headers=headers, body=body)
	
	return (response, content)

	
	
def getSessionId():
	username = raw_input('Username: ')
	password = raw_input('Password: ')
	print 'Trying to login as', username
	sessionId = login(username, password)
	print 'Got sessionId:', sessionId
	validSessionId = yesOrNo('Do you wish to continue?')
	if not validSessionId:
		print 'Check if site is up and if your internet connection is OK.'
		return
	return sessionId
	
	
def getSongs():
	searchPath = raw_input('Where are the songs you want to upload?: ')
	
	songFiles = []
	print '*** SONGS ***'
	for root, dirs, files in os.walk(searchPath):
		for f in files:
			if f.endswith('mp3'):
				filePath = os.path.join(root, f)
				songFiles.append(filePath)
				print 'File:', f
				print 'Song title:', getSongTitle(filePath)
				print
	print '*************'
	print ('Found %d songs!' % len(songFiles))
	
	titlesAreCorrect = yesOrNo('Are the song titles correct?')
	if not titlesAreCorrect:
		print 'Fix those names, slacker! :)'
		return []
		
	return songFiles
	
	

def main():
	print ' _______           _______  _______ '
	print '(  ____ \|\     /|(  ____ \(       )'
	print '| (    \/| )   ( || (    \/| () () |'
	print '| |      | |   | || |      | || || |'
	print '| |      ( (   ) )| | ____ | |(_)| |'
	print '| |       \ \_/ / | | \_  )| |   | |'
	print '| (____/\  \   /  | (___) || )   ( |'
	print '(_______/   \_/   (_______)|/     \|'
	print '************************************'
	print 't4s0thcmdr\'s batch uploader for www.cvgm.net'
		
	print 'Before using this program, all songs must be named according to the site convention, namely:'
	print 'Artist name - Game name - Song title - Platform.mp3'
	print
	
	print '\n' * 3
	songFiles = getSongs()
	if not songFiles:
		return
		
	print '\n' * 3
	sessionId = getSessionId()
	if not sessionId:
		return
		
	print '\n' * 1
	artistId = int(raw_input('What\'s the artist id?: '))
	
	print '\n' * 2
	print 'Please fill the common information for all songs.'
	songInfo = SongInfo.buildFromInput()
	
	print '\n' * 3
	print 'Everything set to begin uploading.'
	answer = yesOrNo('Proceed?')
	print '\nCross your fingers!!!'
	
	print '\n' * 3
	isFirstUploadCorrect = False
	for songFilePath in songFiles:
		print 'Uploading', getSongTitle(songFilePath)
		print
		response, content = upload(sessionId, artistId, songFilePath, songInfo)
		printResponse(response, content)
		print
		
		if not isFirstUploadCorrect:
			print 'Check the website and make sure the song and its info were uploaded correctly.'
			answer = yesOrNo('Did that upload work?')
			if not answer:
				print 'Ooops!!!'
				print 'Notify a moderator of the wrong upload.'
				print 'Try again later with the correct information.'
				return
			isFirstUploadCorrect = True
	
	


if __name__ == '__main__':
	main()


